cmiranda_studiogenesis/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();



Route::group(['middleware' => ['auth']], function() {

    Route::get('/home', 'HomeController@index')->name('home');

    Route::get('tarifas/{id}/create', 'TarifasController@create')->name('tarifas.agregar');

    Route::resource('usuarios', 'UsuariosController');
    Route::resource('categorias', 'CategoriasController');
    Route::resource('productos', 'ProductosController');

    Route::resource('tarifas', 'TarifasController');

});

cmiranda_studiogenesis/app/Categoria.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Categoria extends Model
{
    protected $fillable = ['codigo_categoria', 'nombre_categoria', 'descripcion_categoria'];

    public function productos() {
        return $this->belongsToMany('App\Producto');
    }

}

cmiranda_studiogenesis/app/Http/Controllers/CategoriasController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Categoria;

class CategoriasController extends Controller
{

    //Función index - Recogemos todas las Categorías y las enviamos a la vista 'categorias.index'.
    public function index() {
        $categorias = Categoria::paginate(10);

        return view('categorias.index')->with('categorias', $categorias);
    }

    //Función create - Devolvemos la vista 'categorias.create'.
    public function create() {
        return view('categorias.create');
    }

    //Función store - Recogemos todos los datos vía Request, los validamos y se crea una nueva categoría.
    public function store(Request $request) {

        $request->validate([
            'nombre_categoria' => 'required',
            'descripcion_categoria' => 'required',
        ]);

        $categoria = Categoria::create($request->all());
        $categoria->save();

        //Una vez creada nos redirigimos a la vista 'categorias.index' con un mensaje de confirmación.
        return redirect()->route('categorias.index')->with('success', 'Se ha añadido la categoria correctamente');
    }

    //Función edit - Encontramos la categoría seleccionada por la ID y los enviamos a la vista 'categorias.edit'.
    public function edit($id) {
        $categoria = Categoria::find($id);
        return view('categorias.edit')->with('categoria', $categoria);
    }

    //Función update - Recogemos todos los datos de la categoría, la ID de la categoría a modificar y guardamos los cambios.
    public function update(Request $request, $id) {

        $request->validate([
            'nombre_categoria' => 'required',
            'descripcion_categoria' => 'required',
        ]);

        $categoria = Categoria::find($id);

        $categoria->nombre_categoria = $request->nombre_categoria;
        $categoria->descripcion_categoria = $request->descripcion_categoria;

        $categoria->save();

        //Una vez modificado nos redirigimos a la vista 'categorias.index' con un mensaje de confirmación.
        return redirect()->route('categorias.index')->with('success', 'Se ha modificado la categoria correctamente');
    }

    //Función destroy - Encontramos la categoría seleccionada y si existe se elimina.
    public function destroy($id) {
        $categoria = Categoria::find($id);

        if($categoria) {
            $categoria->delete();
        }

        foreach($categoria->productos as $producto){
            $producto->delete();
        }

        //Una vez eliminado nos redirigimos a la vista 'categorias.index' con un mensaje de confirmación.
        return redirect()->route('categorias.index')->with('success','Se ha eliminado correctamente.');

    }

}

cmiranda_studiogenesis/resources/views/categorias/create.blade.php
@extends('layouts.app')

@section('content')

    <div class="card">
        <div class="card-header">Añadir Categoría</div>
        <div class="card-body">

            @if ($errors->any())
                <div class="alert alert-danger">
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
            @endif

            <form method="POST" action="{{route('categorias.store')}}">
                @csrf

                <div class="form-group">
                    <label for="nombre">Nombre</label>
                    <input type="text" class="form-control" name="nombre_categoria" id="nombre_categoria" required>
                </div>

                <div class="form-group">
                    <label for="descripcion">Descripción</label>
                    <textarea class="form-control" id="descripcion_categoria" name="descripcion_categoria" rows="3" required></textarea>
                </div>

                <a href="{{route('usuarios.index')}}" class="btn btn-danger">Atrás</a>
                <button type="submit" class="btn btn-primary">Añadir</button>
            </form>
        </div>
    </div>

@endsection

cmiranda_studiogenesis/resources/views/categorias/edit.blade.php
@extends('layouts.app')

@section('content')

    <div class="card">
        <div class="card-header">Actualizar Categoría</div>
        <div class="card-body">

            @if ($errors->any())
                <div class="alert alert-danger">
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
            @endif

            <form method="POST" action="{{route('categorias.update', $categoria->id)}}">
                @csrf @method('PATCH')

                <div class="form-group">
                    <label for="nombre">Nombre</label>
                    <input type="text" class="form-control" name="nombre_categoria" id="nombre_categoria" value="{{$categoria->nombre_categoria}}" required>
                </div>

                <div class="form-group">
                    <label for="descripcion">Descripción</label>
                    <textarea class="form-control" id="descripcion_categoria" name="descripcion_categoria" rows="3" required>{{$categoria->descripcion_categoria}}</textarea>
                </div>

                <a href="{{route('categorias.index')}}" class="btn btn-danger">Atrás</a>
                <button type="submit" class="btn btn-primary">Actualizar</button>
            </form>
        </div>
    </div>

@endsection

cmiranda_studiogenesis/resources/views/categorias/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="float-right">
            <a href="{{route('categorias.create')}}" class="btn btn-primary">Añadir Categoría</a>
        </div>
        <h1 style="font-size: 2.2rem">Lista de Categorías</h1>

        @if(session()->get('success'))
            <div class="alert alert-success">
                {{ session()->get('success') }}
            </div>
            <br>
        @endif

        <div class="row justify-content-center">
            <div class="col">
                <table class="table">
                    <thead>
                    <tr>
                        <th scope="col">ID</th>
                        <th scope="col">Nombre</th>
                        <th scope="col">Descripción</th>
                        <th scope="col">Acción</th>
                    </tr>
                    </thead>
                    <tbody>
                    @foreach($categorias as $categoria)
                        <tr>
                            <th>{{$categoria->id}}</th>
                            <th>{{$categoria->nombre_categoria}}</th>
                            <th>{{$categoria->descripcion_categoria}}</th>
                            <th>
                                <a href="{{route('categorias.edit',$categoria->id)}}" class="float-left">
                                    <button type="button" class="btn-primary btn-sm"><i class="far fa-edit"></i></button>
                                </a>
                                <form action="{{ route('categorias.destroy', $categoria->id)}}" method="POST" class="float-left">
                                    @csrf @method('DELETE')
                                    <button type="submit" class="btn-danger btn-sm" onclick="return confirm('Estas seguro que quieres eliminar esta categoría?')"><i class="far fa-trash-alt"></i></button>
                                </form>
                            </th>
                        </tr>
                    @endforeach
                    </tbody>
                </table>
            </div>
        </div>
        {{$categorias->links()}}
    </div>

@endsection